#include "uiapp.h"

int main( void )
{
	UIApp uiapp;
	uiapp.run();

	return 0;
}

/*
 * 함수 : 실행
 * 설명 : 의미없음. uiapp의 기본 실행 루틴
 */
int UIApp::run( void )
{
	while( 1 )
	{
		setcolor( COLOR_SKY );
		cout << "\n[============ ACHA  UI ============]\n";
		setcolor( COLOR_NONE );
		setcolor( COLOR_BLUE );
		cout << "     1.동기화 생성\n";
		cout << "     2.동기화 삭제\n";
		cout << "     3.상태보기\n";
		cout << "     4.프로그램 종료\n";
		setcolor( COLOR_NONE );
		setcolor( COLOR_SKY );
		cout << "[============ ACHA  UI ============]\n";
		setcolor( COLOR_NONE );

		init();

		init_uimodule();

		connect_uimodule();

		if(getCmd())
		{
			if(!receiveDataParsing())
				break;
		}
		else
		{
			break;
		}
	
		
	}

	return 0;
}

int UIApp::cleanup(void)
{

	return 0;
}


/*
 * 함수 : 인자 갯수를 리턴한다.
 */
int argc( char *str )
{
	int count;
	char *tok;
	char buf[BUFSIZ] = "";
	strncpy( buf, str, BUFSIZ );

	tok = strtok( buf, DELIM );
	for( count = 0; tok != NULL; count++ )
	{
		tok = strtok( NULL, DELIM );
	}

	return count;
}

/*
 * 함수 : 텍스트 출력 컬러 설정
 */
void setcolor( int color )
{
	cout << "[00m";

	switch( color )
	{
		case COLOR_RED :
			cout << "[1;31m";
			break;
		case COLOR_GREEN:
			cout << "[1;32m";
			break;
		case COLOR_YELLOW :
			cout << "[1;33m";
			break;
		case COLOR_BLUE :
			cout << "[1;34m";
			break;
		case COLOR_PINK :
			cout << "[1;35m";
			break;
		case COLOR_SKY :
			cout << "[1;36m";
			break;
		case COLOR_WHITE :
			cout << "[1;37m";
			break;
		case COLOR_DARKRED :
			cout << "[31m";
			break;
		case COLOR_DARKGREEN :
			cout << "[32m";
			break;
		case COLOR_BROWN :
			cout << "[33m";
			break;
		case COLOR_DARKBLUE :
			cout << "[34m";
			break;
		case COLOR_PUPLE :
			cout << "[35m";
			break;
		case COLOR_DARKSKY :
			cout << "[36m";
			break;
		case COLOR_GRAY :
			cout << "[37m";
			break;
		default :
			cout << "[00m";
			break;
	}

	return;
}


/*
 * 함수 : 입력받은 스트링이 IP형식인지 확인
 * 반환 : IP형식 - true    else   false
 */
bool isIPformat( char *str )
{
	int a, b, c, d;
	sscanf( str, "%d.%d.%d.%d", &a, &b, &c, &d );
	if( a >  0  && a < 256  &&
		b >= 0  && b < 256  &&
		c >= 0  && d < 256  &&
		d >  0  && d < 256 )
	{
		return true;
	}

	return false;
}

/*
 * 함수 : 초기화 함수
 */
int UIApp::init( void )
{
	bzero( remoteTarget, sizeof(remoteTarget) );
	bzero( buf, sizeof(buf) );
	bzero( cmdBuffer, sizeof(cmdBuffer) );

	listenPort 	= UIM_PORT;
	sendPort	= UIM_PORT;
	controlPort	= CONTROL_PORT;

	isLock 		= false;
//	debugMode	= false;
	demon		= false;

	
        server_len 	= sizeof(server_addr);
	uiapp_len = sizeof(uimodule_addr);


	memset( &serverData, 0, sizeof(serverData) );
	memset( &serverResult, 0, sizeof(serverResult) );
	memset( &uiappData, 0, sizeof(uiappData) );
	memset( &uiappResult, 0, sizeof(uiappResult) );

	fdRecordLock = -1;


	// 디버깅을 위한 타겟 로컬지정
	//strcpy( remoteTarget, "127.0.0.1" );

	return 0;

}

/*
 * 함수 : 소켓 통신을 위한 클라이언트 초기화
 * 인자 : 없음
 * 반환 : 성공 : 0, 실패 : 1
 */
int UIApp::init_uimodule( void )
{
	uimodule_addr.sin_family = AF_INET;
	uimodule_addr.sin_port = htons( sendPort );

	//printf("port = %d", sendPort);

	// 원격지 주소가 IP일 경우
	if( isIPformat( remoteTarget ) )
	{
		printf("원격지 주소가 IP일 경우\n");
		uimodule_addr.sin_addr.s_addr = inet_addr( remoteTarget );
	}
	// 원격지 주소가 domain name 일 경우
	else
	{
		struct hostent *he;
		he = gethostbyname( remoteTarget );

		// gethostbyname 결과 IP를 받아오지 못했을 경우
		if( he == NULL )
		{
			return 1;
		}
		else
		{
			uimodule_addr.sin_addr.s_addr = inet_addr( inet_ntoa( *(struct in_addr*)he->h_addr) );
		}
	}

	return 0;
}


int UIApp::connect_uimodule( void )
{
    if( (uiapp_sockfd = socket(PF_INET, SOCK_STREAM, 0)) < 0 )
    {
		if( debugMode ) puts("connect_client() socket() failed1");
		return -1;
    }
	
    if( connect(uiapp_sockfd, (struct sockaddr *)&uimodule_addr, uiapp_len) < 0)
    {
	
		if( debugMode ) puts("connect_client() connect() failed2");
		if( uiapp_sockfd )
		{

			close( uiapp_sockfd );
		}
		return -1;
	
    }

	return 0;
}

/*
 * 함수 : 사용자로부터 명령을 입력 받음
 * 함수 : buf 에 있는 내용을 원격지로 전송한다.
 * 인자 : 없음
 * 반환 : 성공 : 0, 실패 : -1
 */
int UIApp::sendCmd( int chk, char *cmd )
{
	if( uiapp_sockfd <= 0 )
	{
		if( debugMode ) printf("uimodule_sockfd is not valid.\n");
		sendResult = CM_ACK_NO;
		return CM_ACK_NO;
	}

	// 기본정보 전송
	
	switch(chk)
	{
		case UIM_CREATE_SYNC: //생성
			uiappData.type = UIM_CREATE_SYNC;
			break;

		case UIM_DELETE_SYNC: //삭제
			uiappData.type = UIM_DELETE_SYNC;
			break;

		case UIM_VIEW_SYNCINFO: //내용 보기
			uiappData.type = UIM_VIEW_SYNCINFO;
			break;
	}

	sprintf( uiappData.data, "%s", cmd);
	uiappData.len = strlen( uiappData.data );

	// 전송을 정해진 양만큼만 보냄	
	write( uiapp_sockfd, &uiappData, 
			sizeof(uiappData.type) + sizeof(uiappData.len) + strlen(uiappData.data) );

	if( debugMode )
	{
		setcolor( COLOR_GREEN );
		printf("[Send] [%s] -- ", uiappData.data );
		setcolor( COLOR_NONE );
	}

	// 결과값 수신
	if( chk == UIM_VIEW_SYNCINFO)
	{
		int len = 0;
		int count = 0;	

		memset( &syncData, 0, sizeof(syncData) );
		len = read( uiapp_sockfd, &syncData,
				sizeof(syncData.type) + sizeof(syncData.len) );

		// ACHA Infomation
		if(syncData.type <= 0)	
		{
			setcolor( COLOR_YELLOW );
			printf("\n[======================= ");
			setcolor( COLOR_RED );
			printf("NO ACHA Infomation");
			setcolor( COLOR_YELLOW );
			printf(" =======================]\n");
			setcolor( COLOR_NONE );
		}		
				

		if( syncData.len > 0 )
		{
			read( uiapp_sockfd, &syncData.data, syncData.len );
			//printf("[Receive2222222222222222] [%s]\n", syncData.data );

			// 수신한 데이터를 파싱한다.
			char dataBuf[DATASIZ] = "";
			char in_lock[20] = "";
			char in_debug[20] = "";
			char in_username[256] = "";
			char in_userpass[128] = "";
			char in_recordLockPath[256] = "";
			int in_m_fdRecordLock = 0;

			strncpy( dataBuf, syncData.data, syncData.len );
			strcpy( in_lock, strtok( dataBuf, "|" ) );
			strcpy( in_debug, strtok( NULL, "|") );
			strcpy( in_username, strtok( NULL, "|") );
			strcpy( in_userpass, strtok( NULL, "|") );
			strcpy( in_recordLockPath, strtok( NULL, "|") );		
			in_m_fdRecordLock = atoi(strtok( NULL, "|\0"));	
			
			setcolor( COLOR_SKY );
			printf("\n[======================= ACHA Infomation ========================]\n");
			cout << " Lock / Debug    : " 	<< in_lock << " / " 
									<< in_debug << endl;
			cout << " LoginID / PASS  : " << in_username << " / " << in_userpass << endl;
			cout << " RecordLockPath  : " << in_recordLockPath << " (" << in_m_fdRecordLock << ")" <<endl;	
							
		}

		// SyncList
		while(1)
		{
			memset( &syncData, 0, sizeof(syncData) );
			len = read( uiapp_sockfd, &syncData,
					sizeof(syncData.type) + sizeof(syncData.len) );

			//printf("syncData.type = %d\n", syncData.type);

			if(syncData.type <= 0)	
			{
				setcolor( COLOR_YELLOW );
				printf("\n[========================== ");
				setcolor( COLOR_RED );
				printf("NO SyncList");
				setcolor( COLOR_YELLOW );
				printf(" ==========================]\n");
				setcolor( COLOR_NONE );
				break;
			}
			
			if(count == 0)
			{	
				setcolor( COLOR_SKY );
				printf("\n[============================ SyncList =============================]\n");
				setcolor( COLOR_DARKRED );
				cout << "[SyncName]";
				setcolor( COLOR_DARKGREEN );
				cout << "[  Target  ]";
				setcolor( COLOR_BROWN );
				cout << "[  LocalPath  ]";
				setcolor( COLOR_PUPLE );
				cout << "[  RemotePath  ]"; 				
				setcolor( COLOR_DARKSKY );
				cout << "[ LastSyncTime ]" << endl;
			}

			if( syncData.len > 0 )
			{
				read( uiapp_sockfd, &syncData.data, syncData.len );
				//printf("[Receive] [%s]\n", syncData.data );

				// 수신한 데이터를 파싱한다.
				char dataBuf[DATASIZ] = "";
				char syncName[256] = "";
				char target[256] = "";
				char localPath[512] = "";
				char remotePath[512] = "";
				char lastSyncTime[100] = "";

				strncpy( dataBuf, syncData.data, syncData.len );
				strcpy( syncName, strtok( dataBuf, "|" ) );
				strcpy( target, strtok( NULL, "|") );
				strcpy( localPath, strtok( NULL, "|") );
				strcpy( remotePath, strtok( NULL, "|") );	
				strcpy( lastSyncTime, strtok( NULL, "|\0") );	

				setcolor( COLOR_DARKRED );
				printf("[%s]", syncName);
				setcolor( COLOR_DARKGREEN );
				printf("[%s]", target);
				setcolor( COLOR_BROWN );
				printf("[%s]", localPath);
				setcolor( COLOR_PUPLE );
				printf("[%s]", remotePath);
				setcolor( COLOR_DARKSKY );				
				printf("[%s]\n", lastSyncTime);
				setcolor( COLOR_NONE );		
								
			}

			if( len <= 0 )
			{
				printf("ERROR\n");
				exit(0);
				break;
			}		

			count++;			

			if((signed)count >= (signed)syncData.type)	
				break;
		}

		//memset( &syncData, 0, sizeof(syncData) );
		len = read( uiapp_sockfd, &syncData,
				sizeof(syncData.type) + sizeof(syncData.len) );
		if( syncData.len > 0 && syncData.type > 0)
		{
			read( uiapp_sockfd, &syncData.data, syncData.len );
			//printf("\n[Receive] [%s]\n", syncData.data );

			// 수신한 데이터를 파싱한다.
			char dataBuf2[DATASIZ] = "";
			//int in_lock = 0;
			//int in_debug = 0;
			int in_svrsock = 0;
			int in_listenport = 0;
			char in_client_ip[256] = "";
			int sDt_type = 0;
			int sDt_len = 0;
			char sDt_data[512] = "";
			int in_rtargsock = 0;
			int in_sendport = 0;
			char in_remote_ip[256] = "";
			char in_readdr_ip[256] = "";
			int cDt_type = 0;
			int cDt_len = 0;
			char cDt_data[512] = "";

			strncpy( dataBuf2, syncData.data, syncData.len );
			//in_lock = atoi( strtok( dataBuf2, "|" ) );
			//in_debug = atoi( strtok( NULL, "|" ) );
			//in_svrsock = atoi( strtok( NULL, "|" ) );
			in_svrsock = atoi( strtok( dataBuf2, "|" ) );
			in_listenport = atoi( strtok( NULL, "|" ) );				
			strcpy( in_client_ip, strtok( NULL, "|" ) );
			sDt_type = atoi( strtok( NULL, "|" ) );
			sDt_len = atoi( strtok( NULL, "|" ) );	
			if(sDt_len > 0)
			{
				strcpy( sDt_data, strtok( NULL, "|") );	
			}										
			in_rtargsock = atoi( strtok( NULL, "|" ) );				
			in_sendport = atoi( strtok( NULL, "|" ) );				
			strcpy( in_remote_ip, strtok( NULL, "|") );				
			strcpy( in_readdr_ip, strtok( NULL, "|") );				
			cDt_type = atoi( strtok( NULL, "|" ) );					
			cDt_len = atoi( strtok( NULL, "|" ) );					
			if(cDt_len > 0)
			{
				strcpy( cDt_data, strtok( NULL, "|\0") );
			}				
		
			setcolor( COLOR_SKY );
			printf("[========================  CM Information  =========================]\n");
			//setcolor( COLOR_RED );
			//cout << " CM Lock / Debug  state  : " << in_lock << " / " << in_debug << endl;
			setcolor( COLOR_GREEN );
			cout << " Server_sockfd / port    : " << in_svrsock << " / " << in_listenport << endl;
			setcolor( COLOR_YELLOW );
			cout << " LastClient IP           : " << in_client_ip << endl;
			setcolor( COLOR_BLUE );
			cout << " RecvData                : ";
			printf( "[%d] [%d] [%s]\n", sDt_type, sDt_len, sDt_data );
			setcolor( COLOR_PINK );
			cout << " Target_sockfd / port    : " << in_rtargsock << " / " << in_sendport << endl;
			setcolor( COLOR_BROWN );
			cout << " Remote target IP        : " << in_remote_ip << endl;
			setcolor( COLOR_PUPLE );
			cout << " LastRemote IP           : " << in_readdr_ip << endl;
			setcolor( COLOR_DARKGREEN );
			cout << " SendData                : ";
			printf( "[%d] [%d] [%s]\n", cDt_type, cDt_len, cDt_data );
			setcolor( COLOR_NONE );
		}
		else if(syncData.type <= 0)	
		{
			setcolor( COLOR_YELLOW );
			printf("\n[============================ ");
			setcolor( COLOR_RED );
			printf("NO DATA");
			setcolor( COLOR_YELLOW );
			printf(" ============================]\n");
			setcolor( COLOR_NONE );
		}	

		/*

		count = 0;	

		while(1)
		{
			memset( &syncData, 0, sizeof(syncData) );
			len = read( uiapp_sockfd, &syncData,
					sizeof(syncData.type) + sizeof(syncData.len) );

			//printf("syncData.type = %d\n", syncData.type);

			if(syncData.type <= 0)	
			{
				setcolor( COLOR_YELLOW );
				printf("\n[========================== ");
				setcolor( COLOR_RED );
				printf("NO FM List");
				setcolor( COLOR_YELLOW );
				printf(" ===========================]\n");
				setcolor( COLOR_NONE );
				break;
			}
			
			if(count == 0)
			{	
				setcolor( COLOR_SKY );
				printf("\n[=========================== FM List ============================]\n");
				setcolor( COLOR_DARKRED );
				cout << "[ TYPE ]";
				setcolor( COLOR_DARKGREEN );
				cout << "[  FILENAME  ]";								
				setcolor( COLOR_BROWN );
				cout << "[ MOD_TIME ]" << endl;
			}

			if( syncData.len > 0 )
			{
				read( uiapp_sockfd, &syncData.data, syncData.len );

				// 수신한 데이터를 파싱한다.
				char dataBuf[DATASIZ] = "";
				int type = 0;				
				char data1[25] = "";
				char data2[25] = "";

				strncpy( dataBuf, syncData.data, syncData.len );
				type = atoi( strtok( dataBuf, "|" ) );
				strcpy( data1, strtok( NULL, "|") );
				strcpy( data2, strtok( NULL, "|") );				

				setcolor( COLOR_DARKRED );
				printf("[%d]", type);
				setcolor( COLOR_DARKGREEN );
				printf("[%s]", data1);
				setcolor( COLOR_BROWN );
				printf("[%s]\n", data2);				
				setcolor( COLOR_NONE );		

			}

			count++;			

			if((signed)count >= (signed)syncData.type)	
				break;

			TRACE;

		}

		if(syncData.type <= 0)	
		{
			setcolor( COLOR_YELLOW );
			printf("\n[============================ ");
			setcolor( COLOR_RED );
			printf("NO DATA");
			setcolor( COLOR_YELLOW );
			printf(" ============================]\n");
			setcolor( COLOR_NONE );
		}
*/
		if( len <= 0 )
		{
			printf("ERROR\n");
			exit(0);
		}
		
	}
	else if( chk == UIM_CREATE_SYNC )
	{
		read( uiapp_sockfd, buf, sizeof(buf) );

		if(strcmp(buf,"1") != 0)
		{
			setcolor( COLOR_SKY );
			printf("Sync 생성에 성공하였습니다.\n");
			setcolor( COLOR_NONE );
			sendCmd(UIM_VIEW_SYNCINFO, "3");
		}
		else
		{
			setcolor( COLOR_SKY );
			printf("Sync 생성에 실패하였습니다.\n");
			setcolor( COLOR_NONE );
		}
	}
	else if( chk == UIM_DELETE_SYNC )
	{
		read( uiapp_sockfd, buf, sizeof(buf) );
		if(strcmp(buf,"1") == 0)
		{
			setcolor( COLOR_SKY );
			printf("%s Sync 삭제에 성공하였습니다.\n", uiappData.data);
			setcolor( COLOR_NONE );
		}
		else
		{
			setcolor( COLOR_SKY );
			printf("%s Sync 삭제에 실패하였습니다.\n", uiappData.data);
			setcolor( COLOR_NONE );
		}
	}

	
	if( debugMode )
	{
		setcolor( COLOR_SKY );
		printf("[Receive; debugMode] [%s] --\n", buf );
		setcolor( COLOR_NONE );
	}

	return 0;
}

/*
 * 설명 : UI와 network, 그외 다른 클래스로부터 명령을 입력 받음
 *        디버깅을 위한 함수
 */
bool UIApp::getCmd( void )
{
	//if( demon ) pause();

	bzero( cmdBuffer, sizeof(cmdBuffer) );

	setcolor( COLOR_GREEN );
	cout << "\n\n명령 입력 > ";
	setcolor( COLOR_NONE );

	fgets( cmdBuffer, DATASIZ, stdin );
	cmdBuffer[strlen(cmdBuffer)-1] = '\0';		// cmdBuffer 에서 '\n' 제거

	if( strncmp( cmdBuffer, "exit", strlen("exit") ) == 0 )
	{
		return false;
	}
	
	return true;
}

/*
 * 함수 : 사용자로부터 명령을 입력 받음
 * 설명 : UI와 network, 그외 다른 클래스로부터 명령을 입력 받음
 *        디버깅을 위한 함수
 */
int UIApp::getCmd( char* cmd )
{
	bzero( cmdBuffer, sizeof(cmdBuffer) );
	strncpy( cmdBuffer, cmd, sizeof(cmdBuffer) );
	
	return receiveDataParsing();
}

/*
 * 함수 : 동기화를 생성한다.
 */
int UIApp::createSync( void )
{
	char syncBuf[256];
	char cmd[256];
	char name[SDATA]  	= "";
	char target[SDATA] 	= "";
	char lpath[SDATA]  	= "";
	char rpath[SDATA]  	= "";
	int  flag		= FLAG_NEWSYNC;

	bzero( syncBuf, sizeof(syncBuf) );
	bzero( cmd, sizeof(cmd) );

	setcolor( COLOR_DARKRED );
	cout << "\n[sync_name] ";
	setcolor( COLOR_DARKGREEN );
	cout << "[target_ip] ";
	setcolor( COLOR_BROWN );
	cout << "[local_path] ";
	setcolor( COLOR_PUPLE );
	cout << "[remote_path] ";
	setcolor( COLOR_DARKSKY );
	cout << "[...] \n";
	setcolor( COLOR_NONE );

	fgets( syncBuf, DATASIZ, stdin );
	syncBuf[strlen(syncBuf)-1] = '\0';		// cmdBuffer 에서 '\n' 제거

	//if( strncmp( syncBuf, "add ", strlen("add ") ) == 0  && argc( syncBuf ) == 5 || argc( syncBuf ) == 6 )
	if( argc( syncBuf ) == 4 || argc( syncBuf ) == 5 )
	{
		sprintf(cmd, "%s", syncBuf);
		if( argc( cmd ) == 3 )
		{
			sscanf( cmd, "%s %s %s %s", name, target, lpath, rpath );
			//printf("UIApp::createSync ; cmd = %s\n", cmd );
		}
		else 
		{
			sscanf( cmd, "%s %s %s %s %d", name, target, lpath, rpath, &flag );
			//printf("UIApp::createSync ; cmd = %s\n", cmd );
			bzero( target, sizeof(target) );
			strcpy( target, inet_ntoa( uimodule_addr.sin_addr ) );
			//printf("UIApp::createSync ; name = %s\n", name );
			//printf("UIApp::createSync ; target = %s\n", target );
		}
	}

	return sendCmd(UIM_CREATE_SYNC, cmd);
}

/*
 * 함수 : 동기화를 삭제한다.
 */
int UIApp::deleteSync( void )
{
	char syncBuf[256];	
	bzero( syncBuf, sizeof(syncBuf) );
	
	setcolor( COLOR_DARKRED );
	cout << "\n[sync_name] \n";
	setcolor( COLOR_NONE );

	fgets( syncBuf, DATASIZ, stdin );
	syncBuf[strlen(syncBuf)-1] = '\0';		// cmdBuffer 에서 '\n' 제거
	
	return sendCmd(UIM_DELETE_SYNC, syncBuf);
}

/*
 * 함수 : 받은 데이터 파싱
 * 설명 : 받은 데이터에 대해 해당 함수를 호출한다.
 *        전송 받은 데이터는 멤버변수에 저장된다.
 * 반환 : SendCmd 형 플래그
 */
int UIApp::receiveDataParsing( void )
{
	int cmdLength = strlen( cmdBuffer );

	// 엔터 무시
	if( cmdLength == 0 )
	{
		return true;
	}

	if( strcmp( cmdBuffer, "1" ) == 0 )
    	{
		//printf("동기화 생성\n");

		//connect_uimodule();
		createSync();		
    	}

	if( strcmp( cmdBuffer, "2" ) == 0 )
	{
		//printf("동기화 삭제\n");
		deleteSync();
	}

	if( strcmp( cmdBuffer, "3" ) == 0 )
	{
		//printf("상태 보기\n");
		sendCmd(UIM_VIEW_SYNCINFO, "3");
	}

	if( strcmp( cmdBuffer, "4" ) == 0 )
	{
		//printf("프로그램 종료\n");
		close(uiapp_sockfd);
		return false;
	}


	return true;

}

